/*
 * Joey and its relative products are published under the terms
 * of the Apache Software License.
 */
/*
 * Created on 2004/02/21
 */
package org.asyrinx.brownie.core.sql;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author akima
 */
public class Elements {

	/**
	 *  
	 */
	public Elements(IBuilder builder) {
		super();
		this.builder = builder;
	}

	protected final IBuilder builder;

	protected final List elementList = new ArrayList();

	protected void addImpl(String element) {
		elementList.add(element);
	}

	protected void addImpl(Elements elements) {
		elementList.add(elements);
	}

	/**
	 *  
	 */
	public void clear() {
		elementList.clear();
	}

	/**
	 * @param o
	 * @return
	 */
	public boolean contains(Object o) {
		return elementList.contains(o);
	}

	/**
	 * @param o
	 * @return
	 */
	public int indexOf(Object o) {
		return elementList.indexOf(o);
	}

	/**
	 * @return
	 */
	public boolean isEmpty() {
		return elementList.isEmpty();
	}

	/**
	 * @return
	 */
	public Iterator iterator() {
		return elementList.iterator();
	}

	/**
	 * @param o
	 * @return
	 */
	public boolean remove(Object o) {
		return elementList.remove(o);
	}

	/**
	 * @return
	 */
	public int size() {
		return elementList.size();
	}

}